/** ---------------------------------------------------------------------
 * @file lcd.c
 * @brief t
 * @author ߂ށ€˂Ƌl(http://yaginet.seesaa.net/)
 * @date 2009-01-01
 * 
 ------------------------------------------------------------------------*/
#include<p30f3012.h>
#include<string.h>
#include"lcd.h"

/******************
 * O[oϐ *
 ******************/

/* Jgy[Wʒu */
static SCHAR px = -24;
#define      py   -42

/* y[W̕\e */
static UCHAR vram[84U];

/************
 * ֐ *
 ************/

/* f[^] */
static void lcd_setDB(UCHAR x)
{
    UCHAR i = 0U,j = 7U;

    while(i < 8U){
        SDIN = (x >> j) & 0x01U;
        i++;
        asm("NOP");
        SCLK = 1;
        j--;
        asm("NOP");
        SCLK = 0;
    }
}

/************
 * ֐` *
 ************/

/* LCD */
void lcd_init(void)
{
    RES = 1;
    SCE = 1;
    asm("NOP");
    SCE = 0;
    DC  = 0;
    lcd_setDB(0x20U);
    lcd_setDB(0x0CU);
    SCE = 1;
}

/* y[Wݒ */
void lcd_setPage(UCHAR page)
{
    /* ݋ */
    SCE = 0;
    DC  = 0;

    /* y[WAhXZbg */
    lcd_setDB(0x40U | page);

    /* JAhXZbg */
    lcd_setDB(0x80U);

    /* ݋֎~ */
    SCE = 1;

    /* ʒuݒ */
    px = (page - 3) << 3U;

    /* VRAMNA */
    memset(vram,0x00U,84U);
}

/* 8x8LN^zu */
void lcd_putChar(const UCHAR* code,SCHAR x,SCHAR y)
{
    UCHAR i,y0,y1,shift;
    /* y[Ẅ̗ɕ`Ώۂ݂邩 */
    if( x + 8 <= px      ||
        x     >= px + 8  ||
        y + 8 <= py      ||
        y     >= py + 84  )
    {
        /* `sv */
        return;
    }

    /* `̈ */
    y0 = (y < py) ? 0U:(y - py);
    y1 = (y + 8 >= py + 84) ? 84U:(y + 8 - py);

    /* `Jñf[^̈ʒu */
    if(y < py){
        code += py - y;
    }

    /* Vtgݒ */
    shift = (x >= px) ? (x - px):(px - x);

    /* ` */
    if(x >= px){
        for(i = y0;i < y1;i++){
            vram[i] |= *(code++) << shift;
        }
    }else{
        for(i = y0;i < y1;i++){
            vram[i] |= *(code++) >> shift;
        }
    }
}

/* y[W] */
void lcd_transPage(void)
{
    UCHAR i;

    /* ݋ */
    SCE = 0;
    DC  = 1;

    /* ] */
    for(i = 0U; i < 84U; i++){
        lcd_setDB(vram[i]);
    }

    /* ݋֎~ */
    SCE = 1;
}

