/** ---------------------------------------------------------------------
 * @file sound.c
 * @brief uU[
 * @author ߂ށ€˂Ƌl(http://yaginet.seesaa.net/)
 * @date 2009-01-01
 * 
 ------------------------------------------------------------------------*/
#include<p30f3012.h>
#include<timer.h>
#include<outcompare.h>
#include<stdio.h>
#include"sound.h"

/******************
 * O[oϐ *
 ******************/

/* SEc莞 */
UCHAR seCnt = 0U;

/*  */
static const USHORT bgmDuty[13U] = {0U,0xEEE4U,0xE17CU,0xD4D4U,0xC8E2U,0xBD9CU,0xB2F7U,0xA8ECU,0x9F71U,0x967EU,0x8E0CU,0x8613U,0x7E8CU};

/* ̍ */
static UCHAR        bgmOctave = 1U;
/* ̒ */
static UCHAR        bgmLength = 6U;
/* ݂̉I鎞 */
static UCHAR        bgmRest   = 1U;
/* ݂̉̈ʒu */
static USHORT       bgmPos    = 0U;
/* ݂̊y */
static const UCHAR *bgmTable  = NULL;

/************
 * ֐ *
 ************/

/* yǐi */
static UCHAR getBgmVal(void)
{
    UCHAR c;

    c  = bgmTable[bgmPos >> 1U];
    return (bgmPos++ & 1U) ? (c & 0x0FU):(c >> 4U);
}

/************
 * ֐` *
 ************/

/* BGM */
void initBgm(void)
{
    /* PWM[h */
    OpenOC1(OC_IDLE_CON & OC_TIMER2_SRC & OC_PWM_FAULT_PIN_DISABLE,0U,0U);
    OpenTimer2(T2_ON & T2_GATE_OFF & T2_PS_1_1 & T2_SOURCE_INT,0xFFFFU);
    SetDCOC1PWM(0U);
}

/* BGMݒ */
void setBgm(const UCHAR* tbl)
{
    SetDCOC1PWM(0U);

    seCnt     = 0U;
    bgmOctave = 1U;
    bgmLength = 6U;
    bgmRest   = 1U;
    bgmPos    = 0U;
    bgmTable  = tbl;
}

/* BGMis */
void updateBgm(void)
{
    USHORT s;
    UCHAR  c = 0U,flag = 0U;

    /* yǐiߔ */
    if(--bgmRest == 0U){
        do{
            c = getBgmVal();

            switch(c){
            /* ̍ύX */
            case 0xDU:  bgmOctave--;
                        break;
            case 0xEU:  bgmOctave++;
                        break;
            /* ̒ύX */
            case 0xFU:  c = getBgmVal();
                        if(c){bgmLength = c;}
                        else {bgmPos    = 0U;}
                        break;
            /* ݒ */
            default:    bgmRest = bgmLength;
                        flag    = 1U;
            }
        }while(!flag);
    }

    /* SE */
    if(seCnt){
        s    = (--seCnt == 1U) ? 0xEEE4U:0U;
        flag = 1U;
    }else{
        s = bgmDuty[c] >> bgmOctave;
    }

    /* f[eB[ݒ */
    if(flag){
        OpenTimer2(T2_ON & T2_GATE_OFF & T2_PS_1_1 & T2_SOURCE_INT,s - 1U);
        SetDCOC1PWM(s >> 1U);
    }
}

